/*
 *  Rotate.cpp
 *  ANIMA
 *
 *  Created by [admin] on Mon Sep 02 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */

#include "Rotate.h"
#include <math.h>

void rotate(const unsigned char *src,unsigned char *dest,const int width,const int height,const int origin_x,const int origin_y,const double theta)
{
	const double pi = acos(-1);
	const int rowBytes = width*3;
	
	for (int src_y = 0;src_y < height;src_y++)
	{
		for (int src_x = 0;src_x < width;src_x++)
		{
			// _ݒ
			double x = src_x - origin_x;
			double y = - (src_y - origin_y);
			
			// ɍWɕϊ
			double r = sqrt(x * x + y * y);
			double t;
			if (x == 0)
			{
				if (y > 0) t = pi / 2;
				else t = -(pi / 2);
			}
			else if (y == 0)
			{
				if (x > 0) t = 0;
				else t = pi;
			}
			else if (x > 0)
			{
				t = atan(y / x);
			}
			else if (x < 0 && y > 0)
			{
				t = atan(y / x) + pi;
			}
			else if (x < 0 && y < 0)
			{
				t = atan(y / x) - pi;
			}
			
			// ]
			t += theta;
			if (t > 2 * pi) t -= 2 * pi;
			
			// Wɕϊ
			double new_x = r * cos(t);
			double new_y = r * sin(t);
			
			// XN[Wɕϊ
			int dest_x = (int)new_x + origin_x;
			int dest_y = (int)-new_y + origin_y;
			
			if (dest_x >= 0 && dest_x <= width &&
				dest_y >= 0 && dest_y <= height)
			{
				// vbg
				unsigned char* src_addr = (unsigned char *)(src + src_y*rowBytes + src_x*3);
				unsigned char* dest_addr = (unsigned char *)(dest + dest_y*rowBytes + dest_x*3);
				*(dest_addr  ) = *(src_addr  );
				*(dest_addr+1) = *(src_addr+1);
				*(dest_addr+2) = *(src_addr+2);
				
				if (dest_x > 0)
				{
					dest_addr -= 3;
					*(dest_addr  ) = *(src_addr  );
					*(dest_addr+1) = *(src_addr+1);
					*(dest_addr+2) = *(src_addr+2);
				}
			}
		}
	}
}